const { Builder, By } = require('selenium-webdriver'),
  chrome = require('selenium-webdriver/chrome.js'),
  { expect, it } = require('@jest/globals'),
  chromeOptions = new chrome.Options();

let driver;

chromeOptions.addArguments('--headless', '--disable-gpu', '--no-sandbox');

beforeEach(async () => {
  driver = new Builder().forBrowser('chrome').setChromeOptions(chromeOptions).build();
  await driver.get("http://localhost:3005");
});

it('loads the page', async () => {
  expect(await driver.getTitle()).toEqual('Infantry Combat Solo Basic');
});

it('selects a trooper by clicking on their counter', async () => {
  await driver.switchTo().frame(driver.findElement(By.css('object')));

  const selector = 'use.counter[data-allegiance="liao"][data-number="1"]',
    svg = await driver.findElement(By.css('svg')),
    counter = await driver.findElement(By.css(selector), svg);

  await counter.click();

  expect(await counter.getAttribute('class')).toEqual(expect.stringContaining('selected'));
});

afterEach(async () => await driver.quit());
